#region Copyright Syncfusion Inc. 2001 - 2005
//
//  Copyright Syncfusion Inc. 2001 - 2005. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Chart;
using Syncfusion.Drawing;

namespace Syncfusion.Windows.Forms.Chart.Samples
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private DataSet prodDs1;
		private System.Windows.Forms.Timer timer1;
		private System.ComponentModel.IContainer components;

		private int dataPointsCount;
		private int numPointsPerTimer = 10;
		private int yMax = 1000;
		private int yMin =0;
		private Syncfusion.Windows.Forms.Chart.ChartControl chartControl1;
		private TopArrayModel model = new TopArrayModel();

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
InitializeControlSettings();


			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.timer1 = new System.Windows.Forms.Timer(this.components);
			this.chartControl1 = new Syncfusion.Windows.Forms.Chart.ChartControl();
			this.SuspendLayout();
			// 
			// timer1
			// 
			this.timer1.Interval = 300;
			this.timer1.Tick += new System.EventHandler(this.timer1_Tick);
			// 
			// chartControl1
			// 
			this.chartControl1.Controls.Add(this.chartControl1.Legend);
			this.chartControl1.Depth = 1F;
			this.chartControl1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.chartControl1.EnableXZooming = true;
			this.chartControl1.EnableYZooming = true;
			// 
			// chartControl1.Legend
			// 
			this.chartControl1.Legend.Font = new System.Drawing.Font("Verdana", 10F);
			this.chartControl1.Legend.ItemsShadowColor = System.Drawing.Color.Gray;
			this.chartControl1.Legend.Location = new System.Drawing.Point(444, 59);
			this.chartControl1.Legend.Name = "";
			this.chartControl1.Legend.TabIndex = 3;
			this.chartControl1.LegendPosition = Syncfusion.Windows.Forms.Chart.ChartDock.Floating;
			this.chartControl1.Location = new System.Drawing.Point(0, 0);
			this.chartControl1.Name = "chartControl1";
			this.chartControl1.PrimaryXAxis.LabelAligment = System.Drawing.StringAlignment.Center;
			this.chartControl1.PrimaryXAxis.Orientation = Syncfusion.Windows.Forms.Chart.ChartOrientation.Horizontal;
			this.chartControl1.PrimaryXAxis.SmartDateZoomMonthLevelLabelFormat = "m";
			this.chartControl1.PrimaryYAxis.LabelAligment = System.Drawing.StringAlignment.Center;
			this.chartControl1.PrimaryYAxis.SmartDateZoomMonthLevelLabelFormat = "m";
			this.chartControl1.Rotation = 0.1F;
			this.chartControl1.Size = new System.Drawing.Size(552, 374);
			this.chartControl1.TabIndex = 4;
			this.chartControl1.Text = "Syncfusion Essential Chart";
			this.chartControl1.Tilt = 0.1F;
			this.chartControl1.ToolBar.Location = new System.Drawing.Point(0, 0);
			this.chartControl1.ZoomOutIncrement = 1.5;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(552, 374);
			this.Controls.Add(this.chartControl1);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "Form1";
			this.Text = "Chart Recorder Sample";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.ResumeLayout(false);

		}
		#endregion

		private void InitializeControlSettings()
	  {
			this.chartControl1.Font = new System.Drawing.Font("Arial", 12F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));

		  // Specify a ChartPalette:
		  Color[] color = new Color[]{Color.FromArgb(185, 73,141,238), Color.FromArgb(185,247,179,78),Color.FromArgb(185,186,66,30)};
		  this.chartControl1.Palette = ChartColorPalette.Custom ;
		  this.chartControl1.Model.ColorModel.CustomColors = color;
		  this.chartControl1.Palette = ChartColorPalette.Custom ;

		  this.chartControl1.ChartInterior = new Syncfusion.Drawing.BrushInfo(185,new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.Vertical, Color.LightBlue , Color.Azure));
		  this.chartControl1.LegendPosition = ChartDock.Top;
		this.chartControl1.HidePartialLabels = true;
		this.Text="Essential Chart-Chart Recorder Sample";
	  }

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			try
			{
				Application.Run(new Form1());
			}
			catch (Exception ex)
			{
				MessageBox.Show(ex.ToString());
			}
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			InitializeChart();	
		}

		protected void InitializeChart()
		{
			// Set Indexed to false as we will be using non indexed data
			this.chartControl1.Indexed = false;

			ChartSeries series = this.chartControl1.Model.NewSeries("Products");
			series.Text = series.Name;
			series.SeriesModelImpl = model;
			series.Type = ChartSeriesType.Spline;
			series.Style.DisplayShadow = false;
			series.Style.DisplayText = true;
			series.Style.Interior = new BrushInfo(GradientStyle.None, Color.FromArgb(185,247,179,78), Color.FromArgb(185,247,179,78));
			this.chartControl1.Series.Add(series);

			this.chartControl1.PrimaryXAxis.Title="Time";
			this.chartControl1.PrimaryYAxis.Title="Amplitude";
			this.chartControl1.Text="CRO Output Signal";

			this.chartControl1.Legend.VisibleCheckBox = true;
			this.chartControl1.EnableYZooming = true;
			this.chartControl1.PrimaryYAxis.Format = "#.#";
			this.timer1.Start();			

		}

		private void timer1_Tick(object sender, System.EventArgs e)
		{
			try
			{
				Random rand = new Random();
					
				for(int i =0; i < numPointsPerTimer; i++)
				{
					if((dataPointsCount<100)||(dataPointsCount>200))
					{
						this.model.AddXY(dataPointsCount,new double[]{rand.Next(yMin, yMax)});
					}
					dataPointsCount++;
				}

				this.chartControl1.PrimaryXAxis.Range.Min =0;
				this.chartControl1.PrimaryXAxis.Range.Max =dataPointsCount;

				int visibleRange = 5 * this.numPointsPerTimer;
				if(dataPointsCount > visibleRange)
				{
					model.TopCount = visibleRange;
					this.chartControl1.PrimaryXAxis.Range.Max = dataPointsCount;
					this.chartControl1.PrimaryXAxis.Range.Min = dataPointsCount - visibleRange;
				}
				else
					model.TopCount = 0;

				// Y Axis
				int yVisibleMax = 1000;
				int yVisibleMin = 0;

				if(yVisibleMax <= yMax && yVisibleMin >= yMin)
				{
					double yVisibleRange = yVisibleMax - yVisibleMin;
					double yRange = yMax - yMin;
					this.chartControl1.ZoomFactorY = yVisibleRange/yRange;
					this.chartControl1.ZoomPositionY = 1- yVisibleMin/yRange;
				}
			}
			catch(Exception ex)
			{
				Console.WriteLine(ex.ToString());
			}
		}
	}
}
